## 2026-02-06-21-54-29-sdrangel-v7.23.1.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)

set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")

if(APPLE)
    project(sdrangel LANGUAGES C CXX OBJCXX)
else()
    project(sdrangel)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

# disable only when needed
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# configure version
set(sdrangel_VERSION_MAJOR "7")
set(sdrangel_VERSION_MINOR "23")
set(sdrangel_VERSION_PATCH "1")
set(sdrangel_VERSION_SUFFIX "")

# SDRAngel cmake options
option(DEBUG_OUTPUT "Print debug messages" OFF)
option(SANITIZE_ADDRESS "Activate detection of uninitialized memory (AddressSanitizer)" OFF)
option(SANITIZE_MEMORY "Activate detection of leaked memory (LeakSanitizer)" OFF)
option(RX_SAMPLE_24BIT "Internal 24 bit Rx DSP" ON)
option(BUILD_SERVER "Build Server" ON)
option(BUILD_GUI "Build GUI" ON)
option(BUILD_BENCH "Build benchmark" ON)
option(HIDE_CONSOLE "Hide console when running GUI on Windows" ON)
option(BUNDLE "Enable distribution bundle" OFF)
set(ARCH_OPT "native" CACHE STRING "Specify instruction set to use. Will be passed directly as `-march` or `/arch:` argument on supported compilers. \
                                   'native' option will figure out host machine compatibilities and set flags accordingly (even with MSVC).")
option(ENABLE_QT6 "Build with Qt6 rather than Qt5" OFF)
option(ENABLE_PROFILER "Enable runtime profiler" OFF)
set(VKFFT_BACKEND 1 CACHE STRING "vkFFT Backend: 0 - Vulkan, 1 - CUDA")
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

# Sampling devices enablers
option(ENABLE_AARONIARTSA "Enable AaroniaRTSA support" ON)
option(ENABLE_AIRSPY "Enable AirSpy support" ON)
option(ENABLE_AIRSPYHF "Enable AirSpyHF support" ON)
option(ENABLE_BLADERF "Enable bladeRF support" ON)
option(ENABLE_FUNCUBE "Enable FUNcube support" ON)
option(ENABLE_HACKRF "Enable HackRF support" ON)
option(ENABLE_IIO "Enable liniio support like PlutoSDR" ON)
option(ENABLE_LIMESUITE "Enable limesuite support" ON)
option(ENABLE_METIS "Enable Metis support" ON)
option(ENABLE_MIRISDR "Enable LibMiri for old SDRPlay" ON)
option(ENABLE_PERSEUS "Enable perseus support" ON)
option(ENABLE_RTLSDR "Enable rtl-sdr support" ON)
option(ENABLE_SDRPLAY "Enable SDRplay support" ON)
option(ENABLE_SOAPYSDR "Enable SoapySDR support" ON)
option(ENABLE_XTRX "Enable XTRX support" ON)
option(ENABLE_PACK_MIRSDRAPI "Enable inclusion of the mirsdr-api library - for personal use only" OFF)
option(ENABLE_USRP "Enable USRP support" ON)

# Channel Rx enablers
option(ENABLE_CHANNELRX "Enable channelrx plugins" ON)
option(ENABLE_CHANNELRX_DEMODADSB "Enable channelrx demodadsb plugin" ON)
option(ENABLE_CHANNELRX_DEMODAM "Enable channelrx demodam plugin" ON)
option(ENABLE_CHANNELRX_DEMODDATV "Enable channelrx demoddatv plugin" ON)
option(ENABLE_CHANNELRX_RADIOCLOCK "Enable channelrx radioclock plugin" ON)
option(ENABLE_CHANNELRX_RADIOASTRONOMY "Enable channelrx radioastronomy plugin" ON)
option(ENABLE_CHANNELRX_DEMODRADIOSONDE "Enable channelrx demodradiosonde plugin" ON)
option(ENABLE_CHANNELRX_FREQTRACKER "Enable channelrx freqtracker plugin" ON)
option(ENABLE_CHANNELRX_DEMODATV "Enable channelrx demodatv plugin" ON)
option(ENABLE_CHANNELRX_DEMODPAGER "Enable channelrx demodpager plugin" ON)
option(ENABLE_CHANNELRX_DEMODDAB "Enable channelrx demoddab plugin" ON)
option(ENABLE_CHANNELRX_UDPSINK "Enable channelrx udpsink plugin" ON)
option(ENABLE_CHANNELRX_DEMODAIS "Enable channelrx demodais plugin" ON)
option(ENABLE_CHANNELRX_DEMODNFM "Enable channelrx demodnfm plugin" ON)
option(ENABLE_CHANNELRX_DEMODM17 "Enable channelrx demodm17 plugin" ON)
option(ENABLE_CHANNELRX_FILESINK "Enable channelrx filesink plugin" ON)
option(ENABLE_CHANNELRX_DEMODFREEDV "Enable channelrx demodfreedv plugin" ON)
option(ENABLE_CHANNELRX_DEMODCHIRPCHAT "Enable channelrx demodchirpchat plugin" ON)
option(ENABLE_CHANNELRX_REMOTESINK "Enable channelrx remotesink plugin" ON)
option(ENABLE_CHANNELRX_REMOTETCPSINK "Enable channelrx remotetcpsink plugin" ON)
option(ENABLE_CHANNELRX_DEMODSSB "Enable channelrx demodssb plugin" ON)
option(ENABLE_CHANNELRX_CHANALYZER "Enable channelrx chanalyzer plugin" ON)
option(ENABLE_CHANNELRX_SIGMFFILESINK "Enable channelrx sigmffilesink plugin" ON)
option(ENABLE_CHANNELRX_DEMODBFM "Enable channelrx demodbfm plugin" ON)
option(ENABLE_CHANNELRX_DEMODWFM "Enable channelrx demodwfm plugin" ON)
option(ENABLE_CHANNELRX_NOISEFIGURE "Enable channelrx noisefigure plugin" ON)
option(ENABLE_CHANNELRX_DEMODVOR "Enable channelrx demodvor plugin" ON)
option(ENABLE_CHANNELRX_LOCALSINK "Enable channelrx localsink plugin" ON)
option(ENABLE_CHANNELRX_DEMODPACKET "Enable channelrx demodpacket plugin" ON)
option(ENABLE_CHANNELRX_DEMODAPT "Enable channelrx demodapt plugin" ON)
option(ENABLE_CHANNELRX_DEMODDSD "Enable channelrx demoddsd plugin" ON)
option(ENABLE_CHANNELRX_DEMODFT8 "Enable channelrx demodft8 plugin" ON)
option(ENABLE_CHANNELRX_DEMODNAVTEX "Enable channelrx demodnavtex plugin" ON)
option(ENABLE_CHANNELRX_DEMODRTTY "Enable channelrx demodrtty plugin" ON)
option(ENABLE_CHANNELRX_DEMODILS "Enable channelrx demodils plugin" ON)
option(ENABLE_CHANNELRX_DEMODDSC "Enable channelrx demoddsc plugin" ON)
option(ENABLE_CHANNELRX_HEATMAP "Enable channelrx heatmap plugin" ON)
option(ENABLE_CHANNELRX_FREQSCANNER "Enable channelrx freqscanner plugin" ON)
option(ENABLE_CHANNELRX_ENDOFTRAIN "Enable channelrx end-of-train plugin" ON)
option(ENABLE_CHANNELRX_CHANNELPOWER "Enable channelrx channel power plugin" ON)
option(ENABLE_CHANNELRX_WDSPRX "Enable channelrx WDSP receiver plugin" ON)
option(ENABLE_CHANNELRX_DEMODINMARSAT "Enable channelrx demodinmarsat plugin" ON)

# Channel Tx enablers
option(ENABLE_CHANNELTX "Enable channeltx plugins" ON)
option(ENABLE_CHANNELTX_MODM17 "Enable channeltx modm17 plugin" ON)
option(ENABLE_CHANNELTX_MODNFM "Enable channeltx modnfm plugin" ON)
option(ENABLE_CHANNELTX_MODAIS "Enable channeltx modais plugin" ON)
option(ENABLE_CHANNELTX_LOCALSOURCE "Enable channeltx localsource plugin" ON)
option(ENABLE_CHANNELTX_MODDATV "Enable channeltx moddatv plugin" ON)
option(ENABLE_CHANNELTX_MODAM "Enable channeltx modam plugin" ON)
option(ENABLE_CHANNELTX_MODFREEDV "Enable channeltx modfreedv plugin" ON)
option(ENABLE_CHANNELTX_MODPACKET "Enable channeltx modpacket plugin" ON)
option(ENABLE_CHANNELTX_MODSSB "Enable channeltx modssb plugin" ON)
option(ENABLE_CHANNELTX_UDPSOURCE "Enable channeltx udpsource plugin" ON)
option(ENABLE_CHANNELTX_MODCHIRPCHAT "Enable channeltx modchirpchat plugin" ON)
option(ENABLE_CHANNELTX_MODWFM "Enable channeltx modwfm plugin" ON)
option(ENABLE_CHANNELTX_MODATV "Enable channeltx modatv plugin" ON)
option(ENABLE_CHANNELTX_MOD802.15.4 "Enable channeltx mod802.15.4 plugin" ON)
option(ENABLE_CHANNELTX_REMOTESOURCE "Enable channeltx remotesource plugin" ON)
option(ENABLE_CHANNELTX_FILESOURCE "Enable channeltx filesource plugin" ON)
option(ENABLE_CHANNELTX_MODRTTY "Enable channeltx modrtty plugin" ON)
option(ENABLE_CHANNELTX_MODPSK31 "Enable channeltx modpsk31 plugin" ON)

# Channel MIMO enablers
option(ENABLE_CHANNELMIMO "Enable channelmimo plugins" ON)
option(ENABLE_CHANNELMIMO_INTERFEROMETER "Enable channelmimo interferometer plugin" ON)
option(ENABLE_CHANNELMIMO_DOA2 "Enable channelmimo doa2 plugin" ON)
option(ENABLE_CHANNELMIMO_BEAMSTEERINGCWMOD "Enable channelmimo beamsteeringcwmod plugin" ON)

# Feature enablers
option(ENABLE_FEATURE "Enable feature plugins" ON)
option(ENABLE_FEATURE_LIMERFE "Enable feature limerfe plugin" ON)
option(ENABLE_FEATURE_VORLOCALIZER "Enable feature vorlocalizer plugin" ON)
option(ENABLE_FEATURE_JOGDIALCONTROLLER "Enable feature jogdialcontroller plugin" ON)
option(ENABLE_FEATURE_MAP "Enable feature map plugin" ON)
option(ENABLE_FEATURE_SIMPLEPTT "Enable feature simpleptt plugin" ON)
option(ENABLE_FEATURE_RADIOSONDE "Enable feature radiosonde plugin" ON)
option(ENABLE_FEATURE_ANTENNATOOLS "Enable feature antennatools plugin" ON)
option(ENABLE_FEATURE_SATELLITETRACKER "Enable feature satellitetracker plugin" ON)
option(ENABLE_FEATURE_APRS "Enable feature aprs plugin" ON)
option(ENABLE_FEATURE_DEMODANALYZER "Enable feature demodanalyzer plugin" ON)
option(ENABLE_FEATURE_AMBE "Enable feature ambe plugin" ON)
option(ENABLE_FEATURE_AIS "Enable feature ais plugin" ON)
option(ENABLE_FEATURE_AFC "Enable feature afc plugin" ON)
option(ENABLE_FEATURE_STARTRACKER "Enable feature startracker plugin" ON)
option(ENABLE_FEATURE_RIGCTLSERVER "Enable feature rigctlserver plugin" ON)
option(ENABLE_FEATURE_PERTESTER "Enable feature pertester plugin" ON)
option(ENABLE_FEATURE_GS232CONTROLLER "Enable feature gs232controller plugin" ON)
option(ENABLE_FEATURE_REMOTECONTROL "Enable feature remote control plugin" ON)
option(ENABLE_FEATURE_SKYMAP "Enable feature sky map plugin" ON)
option(ENABLE_FEATURE_SID "Enable feature sid plugin" ON)
option(ENABLE_FEATURE_MORSEDECODER "Enable feature morsedecoder plugin" ON)
option(ENABLE_FEATURE_DENOISER "Enable feature denoiser plugin" ON)

# on windows always build external libraries
if(WIN32)
  set(ENABLE_EXTERNAL_LIBRARIES ON CACHE BOOL "Build external libraries" FORCE)
  # to run fixup_bundle()
  set(BUNDLE ON CACHE BOOL "Enable distribution bundle" FORCE)
endif()

# Set additional project information
set(COMPANY "f4exb")
add_definitions("-DCOMPANY=\"${COMPANY}\"")
set(APPLICATION_NAME "SDRangel")
add_definitions("-DAPPLICATION_NAME=\"${APPLICATION_NAME}\"")
set(APPLICATION_MAINTAINER="Edouard Griffiths, F4EXB <f4exb06@gmail.com>")
set(COPYRIGHT "Copyright (c) 2019 Edouard Griffiths. All rights reserved.")
add_definitions("-DCOPYRIGHT=\"${COPYRIGHT}\"")
set(IDENTIFIER "com.${COMPANY}.${APPLICATION_NAME}")
add_definitions("-DIDENTIFIER=\"${IDENTIFIER}\"")

find_package(Git)
if(GIT_FOUND AND EXISTS "${CMAKE_SOURCE_DIR}/.git/")
  execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    RESULT_VARIABLE res
    OUTPUT_VARIABLE out
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT res)
        string(REGEX REPLACE "^v([0-9]+)\.([0-9]+)\.([0-9]+)" "" git_commit ${out})
        set(sdrangel_VERSION_SUFFIX "${git_commit}")
    endif()
endif()

find_program(CCACHE "ccache")
if(CCACHE AND NOT EMSCRIPTEN)
    message(STATUS "Using ccache ${CCACHE}")
    set(CMAKE_C_COMPILER_LAUNCHER ${CCACHE})
    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
    if(APPLE)
        set(CMAKE_OBJCXX_COMPILER_LAUNCHER ${CCACHE})
    endif()
    set(ENV{CCACHE_SLOPPINESS} pch_defines,time_macros)
endif()

set(sdrangel_VERSION "${sdrangel_VERSION_MAJOR}.${sdrangel_VERSION_MINOR}.${sdrangel_VERSION_PATCH}${sdrangel_VERSION_SUFFIX}" CACHE INTERNAL "")
message(STATUS "${APPLICATION_NAME} Version: ${sdrangel_VERSION}")
add_definitions("-DSDRANGEL_LIB_VERSION=\"${sdrangel_VERSION_MAJOR}.${sdrangel_VERSION_MINOR}.${sdrangel_VERSION_PATCH}\"")
add_definitions("-DSDRANGEL_VERSION=\"${sdrangel_VERSION}\"")

# configure CPACK information
set(CPACK_PACKAGE_NAME "${CMAKE_PROJECT_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "SDR Rx/Tx software for Airspy, Airspy HF+, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay, USRP and FunCube")
set(CPACK_PACKAGE_VENDOR "${COMPANY}")
set(CPACK_PACKAGE_CONTACT "https://github.com/f4exb/sdrangel")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/Readme.md")
set(CPACK_PACKAGE_VERSION "${sdrangel_VERSION_MAJOR}.${sdrangel_VERSION_MINOR}.${sdrangel_VERSION_PATCH}${sdrangel_VERSION_SUFFIX}")
set(CPACK_PACKAGE_VERSION_MAJOR ${sdrangel_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${sdrangel_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${sdrangel_VERSION_PATCH})
set(CPACK_SOURCE_STRIP_FILES true)
set(CPACK_STRIP_FILES true)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/Readme.md")

=== devices/CMakeLists.txt ===
project(devices)

include_directories(
    # export.h
    ${CMAKE_SOURCE_DIR}/exports
    # util/message.h
    ${CMAKE_SOURCE_DIR}/sdrbase
)

if(ENABLE_BLADERF AND LIBBLADERF_FOUND)
    add_subdirectory(bladerf1)
    add_subdirectory(bladerf2)
endif()

if(ENABLE_HACKRF AND LIBHACKRF_FOUND)
    add_subdirectory(hackrf)
endif()

if(ENABLE_LIMESUITE AND LIMESUITE_FOUND)
    add_subdirectory(limesdr)
endif()

if(ENABLE_XTRX AND LIBXTRX_FOUND)
    add_subdirectory(xtrx)
endif()

if(ENABLE_IIO AND LIBIIO_FOUND)
    add_subdirectory(plutosdr)
endif()

if(ENABLE_PERSEUS AND LIBPERSEUS_FOUND)
    add_subdirectory(perseus)
endif()

if(ENABLE_SOAPYSDR AND SOAPYSDR_FOUND)
    add_subdirectory(soapysdr)
endif()

if(ENABLE_USRP AND UHD_FOUND)
    add_subdirectory(usrp)
endif()

if(ENABLE_METIS)
    add_subdirectory(metis)
endif()

=== external/CMakeLists.txt ===
# Many idea are exposed at
#  https://stackoverflow.com/questions/15175318/cmake-how-to-build-external-projects-and-include-their-targets
#  https://crascit.com/2015/07/25/cmake-gtest/
#
# in essence, we need a way to build external libraries before use it;
# we choose add_dependencies() to the target.
# other viable solution is to use execute_process() during config
# but make the configuration dirty

# which version/tag/checkout to use
set(CODEC2_TAG "v1.1.1")
set(CM256CC_TAG "v1.1.2")
set(MBELIB_TAG "lib")
set(SERIALDV_TAG "v1.1.5")
set(DSDCC_TAG "v1.9.6")
set(LIMESUITE_TAG 524cd2e548b11084e6f739b2dfe0f958c2e30354)
set(BLADERF_TAG "2024.05")
if (WIN32)
    # Using old version of libiio on windows, as we get unresolved symbols in dll: serial_create_context_from_uri
    set(LIBIIO_TAG 826563e41b5ce9890b75506f672017de8d76d52d)
else()
    set(LIBIIO_TAG "v0.26")
endif()
set(AIRSPYHF_TAG "87cf12a30f3a0f10f313aab8e54999ca69b753af")
set(PERSEUS_TAG afefa23e3140ac79d845acb68cf0beeb86d09028)
set(MIRISDR_TAG "v2.0.0")
set(LIBSIGMF_TAG "new-namespaces")

set(PTHREADS4W_TAG "Version-2-11-0-release")
set(RTLSDR_TAG "v2.0.1")
set(RTLSDR_UDEV OFF)
set(SOAPYSDR_TAG "1667b4e6301d7ad47b340dcdcd6e9969bf57d843")
set(SOAPYSDR_SDRPLAY_TAG "soapy-sdrplay-0.2.0")
set(SOAPYSDR_AUDIO_TAG "soapy-audio-0.1.1")
set(SOAPYSDR_REMOTE_TAG "soapy-remote-0.5.1")
set(AIRSPY_TAG "cmake4")
set(HACKRF_TAG "adc537331c5bc3165f47648043c570063518ef79")
set(LIBXML2_TAG "v2.10.4")
set(UHD_TAG "v4.9.0.1")
set(BOOST_TAG "1.86.0")
set(BOOST_TAG2 "1_86_0")

# For some external project macros
include(ExternalProject)

# default build destination in windows to avoid Release/Debug folder
if (WIN32)
    # the build will be output on the same folder of sdrangel
    set(COMMON_CMAKE_ARGS
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${SDRANGEL_BINARY_BIN_DIR}
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG=${SDRANGEL_BINARY_BIN_DIR}
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE=${SDRANGEL_BINARY_BIN_DIR}
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO=${SDRANGEL_BINARY_BIN_DIR}
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO=${SDRANGEL_BINARY_LIB_DIR}
            -DCMAKE_POLICY_VERSION_MINIMUM=3.5
            )
elseif (LINUX)
    set(COMMON_CMAKE_ARGS
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${EXTERNAL_BUILD_LIBRARIES}/bin
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG=${EXTERNAL_BUILD_LIBRARIES}/bin
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE=${EXTERNAL_BUILD_LIBRARIES}/bin
            -DCMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO=${EXTERNAL_BUILD_LIBRARIES}/bin
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            -DCMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO=${EXTERNAL_BUILD_LIBRARIES}/lib${LIB_SUFFIX}
            )
endif ()

if(CMAKE_MSVC_RUNTIME_LIBRARY)
  list(APPEND COMMON_CMAKE_ARGS -DCMAKE_POLICY_DEFAULT_CMP0091:STRING=NEW)
  list(APPEND COMMON_CMAKE_ARGS -DCMAKE_MSVC_RUNTIME_LIBRARY=${CMAKE_MSVC_RUNTIME_LIBRARY})
endif()

if(CMAKE_BUILD_TYPE)
  list(APPEND COMMON_CMAKE_ARGS -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
endif()

if(CMAKE_INTERPROCEDURAL_OPTIMIZATION)
  list(APPEND COMMON_CMAKE_ARGS -DCMAKE_POLICY_DEFAULT_CMP0069:STRING=NEW)
  list(APPEND COMMON_CMAKE_ARGS -DCMAKE_INTERPROCEDURAL_OPTIMIZATION=${CMAKE_INTERPROCEDURAL_OPTIMIZATION})
endif()

list(APPEND COMMON_CMAKE_ARGS -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER})
list(APPEND COMMON_CMAKE_ARGS -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER})
if (CMAKE_LINKER)
  list(APPEND COMMON_CMAKE_ARGS -DCMAKE_LINKER=${CMAKE_LINKER})
endif()
if (CMAKE_AR)
  list(APPEND COMMON_CMAKE_ARGS -DCMAKE_AR=${CMAKE_AR})
endif()

list(APPEND COMMON_CMAKE_ARGS -DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD})
list(APPEND COMMON_CMAKE_ARGS -DCMAKE_CXX_STANDARD_REQUIRED=${CMAKE_CXX_STANDARD_REQUIRED})
list(APPEND COMMON_CMAKE_ARGS -DCMAKE_CXX_EXTENSIONS=${CMAKE_CXX_EXTENSIONS})

if (LINUX)
    # macro that create symbolic links
    macro(makeLink src dest target)
        if (NOT EXISTS ${dest})
            add_custom_command(TARGET ${target} PRE_BUILD
                    COMMAND ${CMAKE_COMMAND} -E create_symlink ${src} ${dest} DEPENDS ${dest} COMMENT "mklink ${src} -> ${dest}")
        endif ()
    endmacro()
    # macro that copy folder
    macro(makeCopy src dest target)
        if (NOT EXISTS ${dest})
            add_custom_command(TARGET ${target} PRE_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_directory ${src} ${dest} DEPENDS ${dest} COMMENT "copy ${src} -> ${dest}")
        endif ()
    endmacro()
    # macro that copy file
    macro(makeCopyFile src dest target)
        if (NOT EXISTS ${dest})
            add_custom_command(TARGET ${target} PRE_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dest} DEPENDS ${dest} COMMENT "copy ${src} -> ${dest}")
        endif ()
    endmacro()
else ()
    # macro that create symbolic links
    macro(makeLink src dest target)
        if (NOT EXISTS ${dest})
            add_custom_command(TARGET ${target} POST_BUILD
                    COMMAND ${CMAKE_COMMAND} -E create_symlink ${src} ${dest} DEPENDS ${dest} COMMENT "mklink ${src} -> ${dest}")
        endif ()
    endmacro()

    # macro that copy folder
    macro(makeCopyDir src dest target)
        if (NOT EXISTS ${dest})
            add_custom_command(TARGET ${target} POST_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_directory ${src} ${dest} DEPENDS ${dest} COMMENT "copy ${src} -> ${dest}")
        endif ()
    endmacro()

    # macro that copy file
    macro(makeCopy src dest target)
        if (NOT EXISTS ${dest})
            add_custom_command(TARGET ${target} POST_BUILD
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dest} DEPENDS ${dest} COMMENT "copy ${src} -> ${dest}")
        endif ()
    endmacro()
endif (LINUX)

if (WIN32)
    if (VS2015)
        if (CMAKE_SIZEOF_VOID_P EQUAL 8)
            set(VCREDIST_FILE "vcredist_msvc2015_x64${CMAKE_EXECUTABLE_SUFFIX}" CACHE INTERNAL "")
            # maybe add arm architecture
        else ()
            set(VCREDIST_FILE "vcredist_msvc2015_x86${CMAKE_EXECUTABLE_SUFFIX}" CACHE INTERNAL "")
        endif ()
    elseif (VS2017)
        if (CMAKE_SIZEOF_VOID_P EQUAL 8)
            set(VCREDIST_FILE "vcredist_msvc2017_x64${CMAKE_EXECUTABLE_SUFFIX}" CACHE INTERNAL "")
            # maybe add arm architecture
        else ()
            set(VCREDIST_FILE "vcredist_msvc2017_x86${CMAKE_EXECUTABLE_SUFFIX}" CACHE INTERNAL "")
        endif ()
    else ()
        if (CMAKE_SIZEOF_VOID_P EQUAL 8)
            set(VCREDIST_FILE "vc_redist.x64${CMAKE_EXECUTABLE_SUFFIX}" CACHE INTERNAL "")
            # maybe add arm architecture
        else ()
            set(VCREDIST_FILE "vc_redist.x86${CMAKE_EXECUTABLE_SUFFIX}" CACHE INTERNAL "")
        endif ()
    endif ()
    install(FILES "${EXTERNAL_LIBRARY_FOLDER}/vcredist/${VCREDIST_FILE}" DESTINATION "${INSTALL_BIN_DIR}")
endif (WIN32)

set(MACOS_EXTERNAL_LIBS_FIXUP "${CMAKE_BINARY_DIR}/${INSTALL_LIB_DIR}")

# While some of the following projects are not installed (to save time & space), some have to
# be so that on MacOS, the paths embedded in the libraries to other libraries are correct (as they are set to
# install path, not build). This is required for macdeployqt to be able to find them

# Some of the following projects are currently built only for MacOS
# For WIN32, we use precompiled versions from sdrangel-windows-libraries
# For LINUX, we require system pacakges to be installed
if (APPLE)
    set(USE_PRECOMPILED_LIBS FALSE)
else()
    set(USE_PRECOMPILED_LIBS TRUE)
endif()

# We don't CACHE the _DEPENDS variables, as some external projects are only added when NOT _FOUND
# and not in subsequent configures when _FOUND (E.g. ffmpeg/opencv aren't added second time
# around as it slows down the build and causes some dependencies to always be rebuilt.)
# Use PARENT_SCOPE so they can be used in other CMakeFiles.
macro(set_global NAME VALUE)
    set(${NAME} ${VALUE})
    set(${NAME} ${VALUE} PARENT_SCOPE)
endmacro()

# Setting a cache variable doesn't update the variable in parent scope if already set,
# so we need to set the cache and parent_scope separately
macro(set_global_cache NAME VALUE)
    set(${NAME} ${VALUE} CACHE INTERNAL "")
    set(${NAME} ${VALUE} PARENT_SCOPE)
endmacro()

if (NOT LIBUSB_FOUND AND NOT USE_PRECOMPILED_LIBS)
    # Cloning git repo doesn't include configure, so we download the bz2 which does
    ExternalProject_Add(libusb
            URL https://github.com/libusb/libusb/releases/download/v1.0.29/libusb-1.0.29.tar.bz2
            PREFIX "${EXTERNAL_BUILD_LIBRARIES}/libusb"
            CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=<INSTALL_DIR>
            BUILD_COMMAND ${MAKE}
            TEST_COMMAND ""
            )
    ExternalProject_Get_Property(libusb install_dir)
    set_global(LIBUSB_DEPENDS libusb)
    set_global_cache(LIBUSB_FOUND ON)
    set(LIBUSB_EXTERNAL ON CACHE INTERNAL "")
    set(LIBUSB_INCLUDE_DIR "${install_dir}/include/libusb-1.0" CACHE INTERNAL "")
    if (WIN32)
        set(LIBUSB_LIBRARIES "${SDRANGEL_BINARY_LIB_DIR}/libusb.lib" CACHE INTERNAL "")
    elseif (LINUX)
        set(LIBUSB_LIBRARIES "${install_dir}/lib${LIB_SUFFIX}/libusb-1.0${CMAKE_SHARED_LIBRARY_SUFFIX}" CACHE INTERNAL "")
    elseif (APPLE)
        set(LIBUSB_LIBRARIES "${install_dir}/lib/libusb-1.0${CMAKE_SHARED_LIBRARY_SUFFIX}" CACHE INTERNAL "")
        set(MACOS_EXTERNAL_LIBS_FIXUP "${MACOS_EXTERNAL_LIBS_FIXUP};${install_dir}/lib")
    endif ()
endif (NOT LIBUSB_FOUND AND NOT USE_PRECOMPILED_LIBS)

if (NOT HIDAPI_FOUND AND NOT USE_PRECOMPILED_LIBS AND ENABLE_FUNCUBE)
    ExternalProject_Add(hidapi
            GIT_REPOSITORY https://github.com/libusb/hidapi.git
            PREFIX "${EXTERNAL_BUILD_LIBRARIES}/hidapi"
            CMAKE_ARGS ${COMMON_CMAKE_ARGS} -DCMAKE_INSTALL_PREFIX=<INSTALL_DIR>
            TEST_COMMAND ""
            )
    ExternalProject_Get_Property(hidapi install_dir)
    set_global(HIDAPI_DEPENDS hidapi)
    set_global_cache(HIDAPI_FOUND ON)
    set(HIDAPI_EXTERNAL ON CACHE INTERNAL "")
    set(HIDAPI_ROOT_DIR "${install_dir}" CACHE INTERNAL "")
    set(HIDAPI_INCLUDE_DIRS "${install_dir}/include/hidapi" CACHE INTERNAL "")
    if (APPLE)
        set(HIDAPI_LIBRARIES "${install_dir}/lib/libhidapi${CMAKE_SHARED_LIBRARY_SUFFIX}" CACHE INTERNAL "")
        set(MACOS_EXTERNAL_LIBS_FIXUP "${MACOS_EXTERNAL_LIBS_FIXUP};${install_dir}/lib")
    endif ()
endif ()

if (NOT OPUS_FOUND AND NOT USE_PRECOMPILED_LIBS)
    ExternalProject_Add(opus
            GIT_REPOSITORY https://github.com/xiph/opus
            GIT_TAG v1.5.2
            PREFIX "${EXTERNAL_BUILD_LIBRARIES}/opus"

=== ft8/CMakeLists.txt ===
project(ft8)

set(ft8_SOURCES
    arrays.cpp
    fft.cpp
    fftbuffers.cpp
    ft8.cpp
    ft8plan.cpp
    ft8plans.cpp
    ft8stats.cpp
    libldpc.cpp
    osd.cpp
    packing.cpp
    pack0.cpp
    unpack0.cpp
    util.cpp
)

set(ft8_HEADERS
    arrays.h
    fft.h
    fftbuffers.h
    ft8.h
    ft8plan.h
    ft8plans.h
    ft8stats.h
    libldpc.h
    osd.h
    packing.h
    pack0.h
    unpack0.h
    util.h
)

include_directories(
    ${FFTW3F_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/exports
    ${CMAKE_SOURCE_DIR}/sdrbase
)

add_library(ft8
    ${ft8_SOURCES}
)

if(DEFINED FFTW3F_DEPENDS)
    add_dependencies(ft8 "${FFTW3F_DEPENDS}")
endif()

target_link_libraries(ft8
    Boost::disable_autolinking
    ${FFTW3F_LIBRARIES}
    Qt::Core
    sdrbase
)

# remove or comment when debugging is done
# set_property(TARGET ft8 PROPERTY COMPILE_OPTIONS "$<$<CONFIG:Debug>:-Og>")

install(TARGETS ft8 DESTINATION ${INSTALL_LIB_DIR})

=== httpserver/CMakeLists.txt ===
project(httpserver)

set(httpserver_SOURCES
   httpglobal.cpp
   httplistener.cpp
   httpconnectionhandler.cpp
   httpconnectionhandlerpool.cpp
   httprequest.cpp
   httpresponse.cpp
   httpcookie.cpp
   httprequesthandler.cpp
   httpsession.cpp
   httpsessionstore.cpp
   staticfilecontroller.cpp
)

set(httpserver_HEADERS
   httpglobal.h
   httplistener.h
   httpconnectionhandler.h
   httpconnectionhandlerpool.h
   httprequest.h
   httpresponse.h
   httpcookie.h
   httprequesthandler.h
   httpsession.h
   httpsessionstore.h
   staticfilecontroller.h
   httplistenersettings.h
   httpdocrootsettings.h
   httpsessionssettings.h
)

include_directories(
    ${CMAKE_SOURCE_DIR}/exports
)

add_library(httpserver
	${httpserver_SOURCES}
)

target_link_libraries(httpserver
    Qt::Core
    Qt::Network
)

install(TARGETS httpserver DESTINATION ${INSTALL_LIB_DIR})

=== logging/CMakeLists.txt ===
project(logging)

set(logging_SOURCES
   bufferlogger.cpp
   dualfilelogger.cpp
   loggerwithfile.cpp
   filelogger.cpp
   logger.cpp
   logmessage.cpp
)

set(logging_HEADERS
   bufferlogger.h
   dualfilelogger.h
   loggerwithfile.h
   filelogger.h
   logger.h
   logmessage.h
   logglobal.h
)

include_directories(
    ${CMAKE_SOURCE_DIR}/exports
)

add_library(logging
    ${logging_SOURCES}
)

target_link_libraries(logging
    Qt::Core
    Qt::Network
)

install(TARGETS logging DESTINATION ${INSTALL_LIB_DIR})

=== modemm17/CMakeLists.txt ===
project(modemm17)

set(modemm17_SOURCES
    ClockRecovery.cpp
    Correlator.cpp
    FreqDevEstimator.cpp
    Golay24.cpp
    LinkSetupFrame.cpp
    M17Demodulator.cpp
    M17Modulator.cpp
    M17Randomizer.cpp
)

set(modemm17_HEADERS
    ax25_frame.h
    CarrierDetect.h
    ClockRecovery.h
    Convolution.h
    Correlator.h
    CRC16.h
    DataCarrierDetect.h
    DeviationError.h
    Filter.h
    FirFilter.h
    FreqDevEstimator.h
    FrequencyError.h
    Fsk4Demod.h
    Golay24.h
    IirFilter.h
    LinkSetupFrame.h
    M17Demodulator.h
    M17FrameDecoder.h
    M17Framer.h
    M17Modulator.h
    M17Randomizer.h
    M17Synchronizer.h
    PhaseEstimator.h
    PolynomialInterleaver.h
    SlidingDFT.h
    SymbolEvm.h
    Trellis.h
    Util.h
    Viterbi.h
)

include_directories(
    ${CMAKE_SOURCE_DIR}/exports
)

add_library(modemm17
	${modemm17_SOURCES}
)

target_link_libraries(modemm17
    Qt::Core
)

install(TARGETS modemm17 DESTINATION ${INSTALL_LIB_DIR})

=== plugins/CMakeLists.txt ===
project(plugins)

include_directories(
    ${CMAKE_SOURCE_DIR}/sdrbase
    ${CMAKE_SOURCE_DIR}/exports
    ${CMAKE_SOURCE_DIR}/sdrgui
)

if (NOT SERVER_MODE)
    if(WIN32)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${BUILD_PLUGINS_RUNTIME_DIR}")
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINS_RUNTIME_DIR}")
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINS_RUNTIME_DIR}")
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINS_RUNTIME_DIR}")
    endif()
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${BUILD_PLUGINS_DIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINS_DIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINS_DIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINS_DIR}")
    if(WIN32 AND Qt6_FOUND)
        # https://bugreports.qt.io/browse/QTBUG-124589
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${BUILD_PLUGINS_RUNTIME_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINS_RUNTIME_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINS_RUNTIME_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINS_RUNTIME_DIR}")
    else()
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${BUILD_PLUGINS_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINS_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINS_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINS_DIR}")
    endif()
else()
    if(WIN32)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
    endif()
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${BUILD_PLUGINSSRV_DIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINSSRV_DIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINSSRV_DIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINSSRV_DIR}")
    if(WIN32 AND Qt6_FOUND)
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINSSRV_RUNTIME_DIR}")
    else()
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${BUILD_PLUGINSSRV_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${BUILD_PLUGINSSRV_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${BUILD_PLUGINSSRV_DIR}")
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO "${BUILD_PLUGINSSRV_DIR}")
    endif()
endif()

if (ENABLE_CHANNELMIMO)
    add_subdirectory(channelmimo)
endif()

if (ENABLE_CHANNELRX)
    add_subdirectory(channelrx)
endif()

if (ENABLE_CHANNELTX)
    add_subdirectory(channeltx)
endif()

if (ENABLE_FEATURE)
    add_subdirectory(feature)
endif()

add_subdirectory(samplemimo)
add_subdirectory(samplesource)
add_subdirectory(samplesink)

=== qrtplib/CMakeLists.txt ===
project(qrtplib)

set (qrtplib_HEADERS
    rtcpapppacket.h
    rtcpbyepacket.h
    rtcpcompoundpacket.h
    rtcpcompoundpacketbuilder.h
    rtcppacket.h
    rtcppacketbuilder.h
    rtcprrpacket.h
    rtcpscheduler.h
    rtcpsdesinfo.h
    rtcpsdespacket.h
    rtcpsrpacket.h
    rtcpunknownpacket.h
    rtpaddress.h
    rtpcollisionlist.h
    rtpconfig.h
    rtpdefines.h
    rtpendian.h
    rtperrors.h
    rtpinternalsourcedata.h
    rtpkeyhashtable.h
    rtppacket.h
    rtppacketbuilder.h
    rtprandom.h
    rtprandomrand48.h
    rtprandomrands.h
    rtprandomurandom.h
    rtprawpacket.h
    rtpsession.h
    rtpsessionparams.h
    rtpsessionsources.h
    rtpsourcedata.h
    rtpsources.h
    rtpstructs.h
    rtptimeutilities.h
    rtptransmitter.h
    rtptypes_win.h
    rtptypes.h
    rtpudptransmitter.h
    rtpsocketutil.h
    )

set(qrtplib_SOURCES
    rtcpapppacket.cpp
    rtcpbyepacket.cpp
    rtcpcompoundpacket.cpp
    rtcpcompoundpacketbuilder.cpp
    rtcppacketbuilder.cpp
    rtcprrpacket.cpp
    rtcpscheduler.cpp
    rtcpsdesinfo.cpp
    rtcpsdespacket.cpp
    rtcpsrpacket.cpp
    rtpaddress.cpp
    rtpcollisionlist.cpp
    rtperrors.cpp
    rtpinternalsourcedata.cpp
    rtppacket.cpp
    rtppacketbuilder.cpp
    rtprandom.cpp
    rtprandomrand48.cpp
    rtprandomrands.cpp
    rtprandomurandom.cpp
    rtpsession.cpp
    rtpsessionparams.cpp
    rtpsessionsources.cpp
    rtpsourcedata.cpp
    rtpsources.cpp
    rtptimeutilities.cpp
    rtpudptransmitter.cpp
    )

include_directories(
    ${CMAKE_SOURCE_DIR}/exports
)

add_library(qrtplib
    ${qrtplib_SOURCES}
)

target_link_libraries(qrtplib
    Qt::Core
    Qt::Network
)

install(TARGETS qrtplib DESTINATION ${INSTALL_LIB_DIR})

=== scriptsapi/requirements.txt ===
requests
Flask
numpy
websockets
websocket-client
mock

=== sdrbase/CMakeLists.txt ===
project (sdrbase)

if(WIN32)
    # This should probably be in ../CMakeLists.txt with the other variables like it
    set(OPUS_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/external/windows/libopus/include")
    set(OPUS_LIBRARIES "${CMAKE_SOURCE_DIR}/external/windows/libopus/lib/x64/libopus.lib")
endif()
find_package(Opus REQUIRED)

if(FFTW3F_FOUND)
    set(sdrbase_SOURCES
        ${sdrbase_SOURCES}
        dsp/fftwengine.cpp
    )
    set(sdrbase_HEADERS
        ${sdrbase_HEADERS}
        dsp/fftwengine.h
    )
    add_definitions(-DUSE_FFTW)
    include_directories(${FFTW3F_INCLUDE_DIRS})
    set(sdrbase_FFTW3F_LIB ${FFTW3F_LIBRARIES})
endif(FFTW3F_FOUND)

# Kiss FFT is always available
set(sdrbase_SOURCES
    ${sdrbase_SOURCES}
    dsp/kissengine.cpp
    dsp/kissfft.h
)
set(sdrbase_HEADERS
    ${sdrbase_HEADERS}
    dsp/kissengine.h
)
add_definitions(-DUSE_KISSFFT)

# Vulkan SDK: https://vulkan.lunarg.com/
# Windows Vulkan SDK is missing glslang_c_interface.h
# See bug: https://vulkan.lunarg.com/issue/view/63d158a85df11200d569b2ab
# Copy it from Linux SDK
if (${VKFFT_BACKEND} EQUAL 0)
    find_package(Vulkan COMPONENTS glslang SPIRV-Tools)
    if(Vulkan_FOUND)
        set(sdrbase_SOURCES
            ${sdrbase_SOURCES}
            dsp/vulkanvkfftengine.cpp
            dsp/vulkanvkfftengine.h
        )
    endif()
endif()

# CUDA Toolkit: https://developer.nvidia.com/cuda-downloads
if (${VKFFT_BACKEND} EQUAL 1)
    find_package(CUDAToolkit)
    if(CUDA_FOUND)
        enable_language(CUDA)
        set(sdrbase_SOURCES
            ${sdrbase_SOURCES}
            dsp/cudavkfftengine.cpp
            dsp/cudavkfftengine.h
        )
    endif()
    if(WIN32)
        set(WINDOWS_FIXUP_BUNDLE_LIB_DIRS ${WINDOWS_FIXUP_BUNDLE_LIB_DIRS} ${CUDA_TOOLKIT_ROOT_DIR}/bin PARENT_SCOPE)
    endif()
endif()

if((Vulkan_FOUND AND (${VKFFT_BACKEND} EQUAL 0)) OR (CUDA_FOUND AND (${VKFFT_BACKEND} EQUAL 1)))
    set(sdrbase_SOURCES
        ${sdrbase_SOURCES}
        dsp/vkfftengine.cpp
        dsp/vkfftengine.h
        dsp/vkfftutils.cpp
        dsp/vkfftutils.h
    )
    include_directories(${VKFFT_INCLUDE_DIR})
endif()

if (LIBSIGMF_FOUND)
    set(sdrbase_SOURCES
        ${sdrbase_SOURCES}
        dsp/sigmffilerecord.cpp
    )
    set(sdrbase_HEADERS
        ${sdrbase_HEADERS}
        dsp/sigmf_forward.h
        dsp/sigmffilerecord.h
    )
    include_directories(${LIBSIGMF_INCLUDE_DIR})
endif()

if (LIBSERIALDV_FOUND)
    add_definitions(-DDSD_USE_SERIALDV)
    include_directories(${LIBSERIALDV_INCLUDE_DIR})
    set(sdrbase_SERIALDV_LIB ${LIBSERIALDV_LIBRARY})
endif()

set(sdrbase_SOURCES
    ${sdrbase_SOURCES}

    audio/audiocompressor.cpp
    audio/audiocompressorsnd.cpp
    audio/audiodeviceinfo.cpp
    audio/audiodevicemanager.cpp
    audio/audiofifo.cpp
    audio/audiofilter.cpp
    audio/audiog722.cpp
    audio/audioopus.cpp
    audio/audiooutputdevice.cpp
    audio/audioinputdevice.cpp
    audio/audionetsink.cpp
    audio/audioresampler.cpp

    channel/channelapi.cpp
    channel/channelutils.cpp
    channel/channelwebapiutils.cpp
    channel/remotedataqueue.cpp
    channel/remotedatareadqueue.cpp

    commands/command.cpp
    commands/commandkeyreceiver.cpp

    dsp/afsquelch.cpp
    dsp/agc.cpp
    dsp/downchannelizer.cpp
    dsp/upchannelizer.cpp
    dsp/channelmarker.cpp
    dsp/ctcssdetector.cpp
    dsp/ctcssfrequencies.cpp
    dsp/channelsamplesink.cpp
    dsp/channelsamplesource.cpp
    dsp/costasloop.cpp
    dsp/cwkeyer.cpp
    dsp/cwkeyersettings.cpp
    dsp/datafifo.cpp
    dsp/dcscodes.cpp
    dsp/decimatorsff.cpp
    dsp/decimatorsfi.cpp
    dsp/decimatorc.cpp
    dsp/dspcommands.cpp
    dsp/dspengine.cpp
    dsp/dspdevicesourceengine.cpp
    dsp/dspdevicesinkengine.cpp
    dsp/dspdevicemimoengine.cpp
    dsp/fftcorr.cpp
    dsp/fftengine.cpp
    dsp/fftfactory.cpp
    dsp/fftfilt.cpp
    dsp/fftnr.cpp
    dsp/fftwindow.cpp
    dsp/filterrc.cpp
    dsp/filtermbe.cpp
    dsp/filerecord.cpp
    dsp/filerecordinterface.cpp
    dsp/firfilter.cpp
    dsp/fmpreemphasis.cpp
    dsp/freqlockcomplex.cpp
    dsp/interpolator.cpp
    dsp/glscopesettings.cpp
    dsp/spectrumsettings.cpp
    dsp/goertzel.cpp
    dsp/hbfilterchainconverter.cpp
    dsp/hbfiltertraits.cpp
    dsp/mimochannel.cpp
    dsp/morsedemod.cpp
    dsp/nco.cpp
    dsp/phaselock.cpp
    dsp/phaselockcomplex.cpp
    dsp/projector.cpp
    dsp/samplemififo.cpp
    dsp/samplemofifo.cpp
    dsp/samplesinkfifo.cpp
    dsp/samplesimplefifo.cpp
    dsp/samplesourcefifo.cpp
    dsp/scopevis.cpp
    dsp/basebandsamplesink.cpp
    dsp/basebandsamplesource.cpp
    dsp/recursivefilters.cpp
    dsp/wfir.cpp
    dsp/devicesamplesource.cpp
    dsp/devicesamplesink.cpp
    dsp/devicesamplemimo.cpp
    dsp/devicesamplestatic.cpp
    dsp/spectrummarkers.cpp
    dsp/spectrumcalibrationpoint.cpp
    dsp/spectrumvis.cpp
    dsp/wavfilerecord.cpp

    device/deviceapi.cpp
    device/deviceenumerator.cpp
    device/deviceset.cpp
    device/deviceuserargs.cpp
    device/deviceutils.cpp

    feature/feature.cpp
    feature/featureset.cpp
    feature/featureutils.cpp
    feature/featurewebapiutils.cpp

    pipes/datafifostore.cpp
    pipes/datapipes.cpp
    pipes/datapipesgcworker.cpp
    pipes/messagepipes.cpp
    pipes/messagepipesgcworker.cpp
    pipes/messagequeuestore.cpp
    pipes/objectpipe.cpp
    pipes/objectpipesregistrations.cpp

    settings/configuration.cpp
    settings/featuresetpreset.cpp
    settings/pluginpreset.cpp
    settings/preferences.cpp
    settings/preset.cpp
    settings/mainsettings.cpp
    settings/rollupstate.cpp

    util/airlines.cpp
    util/ais.cpp
    util/android.cpp
    util/aprsfi.cpp
    util/aviationweather.cpp
    util/ax25.cpp
    util/aprs.cpp
    util/astronomy.cpp
    util/aurora.cpp
    util/azel.cpp
    util/baudot.cpp
    util/callsign.cpp
    util/colormap.cpp
    util/coordinates.cpp
    util/corsproxy.cpp
    util/countrydat.cpp
    util/crc.cpp
    util/CRC64.cpp
    util/csv.cpp
    util/db.cpp
    util/dsc.cpp
    util/fixedtraits.cpp
    util/fits.cpp
    util/flightinformation.cpp
    util/ft8message.cpp
    util/giro.cpp
    util/goesxray.cpp
    util/golay2312.cpp
    util/grb.cpp
    util/httpdownloadmanager.cpp
    util/interpolation.cpp
    util/kiwisdrlist.cpp
    util/lfsr.cpp
    util/maidenhead.cpp
    util/message.cpp
    util/messagequeue.cpp
    util/mmsi.cpp
    util/morse.cpp
    util/nasaglobalimagery.cpp
    util/navtex.cpp
    util/openaip.cpp
    util/osndb.cpp
    util/ourairportsdb.cpp
    util/peakfinder.cpp
    util/planespotters.cpp
    util/png.cpp
    util/prettyprint.cpp
    util/profiler.cpp
    util/psk31.cpp
    util/radiosonde.cpp
    util/rainviewer.cpp
    util/rtpsink.cpp
    util/syncmessenger.cpp
    util/samplesourceserializer.cpp
    util/sdrangelserverlist.cpp
    util/simpleserializer.cpp
    util/serialutil.cpp
    util/socket.cpp
    util/solardynamicsobservatory.cpp
    util/sondehub.cpp
    #util/spinlock.cpp
    util/spyserverlist.cpp
    util/stix.cpp
    util/stringlist.cpp
    util/rtty.cpp
    util/uid.cpp
    util/units.cpp
    util/timeutil.cpp
    util/visa.cpp
    util/vlftransmitters.cpp
    util/waypoints.cpp
    util/weather.cpp
    util/whittakereilers.cpp
    util/iot/device.cpp
    util/iot/homeassistant.cpp
    util/iot/tplink.cpp
    util/iot/visa.cpp

    plugin/plugininterface.cpp
    plugin/pluginapi.cpp
    plugin/pluginmanager.cpp

    webapi/webapiadapter.cpp
    webapi/webapiadapterbase.cpp
    webapi/webapiadapterinterface.cpp
    webapi/webapirequestmapper.cpp
    webapi/webapiserver.cpp
    webapi/webapiutils.cpp

    websockets/wsspectrum.cpp

    availablechannelorfeature.cpp
    availablechannelorfeaturehandler.cpp
    mainparser.cpp
    maincore.cpp
    remotetcpsinkstarter.cpp

    resources/data.qrc
    resources/webapi.qrc
)

set(sdrbase_HEADERS
    ${sdrbase_HEADERS}

    audio/audiocompressor.h
    audio/audiocompressorsnd.h
    audio/audiodeviceinfo.h
    audio/audiodevicemanager.h
    audio/audiofifo.h
    audio/audiofilter.h
    audio/audiog722.h
    audio/audiooutputdevice.h
    audio/audioopus.h
    audio/audioinputdevice.h
    audio/audionetsink.h
    audio/audioresampler.h

    channel/channelapi.h
    channel/channelutils.h
    channel/channelwebapiutils.h
    channel/remotedataqueue.h
    channel/remotedatareadqueue.h
    channel/remotedatablock.h

    commands/command.h
    commands/commandkeyreceiver.h

    dsp/afsquelch.h
    dsp/autocorrector.h
    dsp/downchannelizer.h
    dsp/upchannelizer.h
    dsp/channelmarker.h
    dsp/channelsamplesink.h
    dsp/channelsamplesource.h
    dsp/complex.h
    dsp/costasloop.h
    dsp/ctcssdetector.h
    dsp/ctcssfrequencies.h
    dsp/cwkeyer.h
    dsp/cwkeyersettings.h
    dsp/datafifo.h
    dsp/dcscodes.h
    dsp/decimators.h
    dsp/decimatorsif.h
    dsp/decimatorsff.h
    dsp/decimatorsfi.h
    dsp/decimatorsu.h
    dsp/decimatorc.h
    dsp/interpolators.h
    dsp/interpolatorsif.h
    dsp/dspcommands.h
    dsp/dspengine.h
    dsp/dspdevicesourceengine.h
    dsp/dspdevicesinkengine.h
    dsp/dspdevicemimoengine.h
    dsp/dsptypes.h
    dsp/fftcorr.h
    dsp/fftengine.h
    dsp/fftfactory.h
    dsp/fftfilt.h
    dsp/fftnr.h
    dsp/fftwengine.h
    dsp/fftwindow.h
    dsp/filterrc.h
    dsp/filtermbe.h
    dsp/filerecord.h
    dsp/filerecordinterface.h
    dsp/firfilter.h
    dsp/fmpreemphasis.h
    dsp/freqlockcomplex.h
    dsp/gfft.h
    dsp/glscopesettings.h
    dsp/glspectruminterface.h
    dsp/spectrummarkers.h
    dsp/spectrumcalibrationpoint.h
    dsp/spectrumsettings.h
    dsp/goertzel.h
    dsp/hbfilterchainconverter.h
    dsp/iirfilter.h
    dsp/interpolator.h
    dsp/hbfiltertraits.h
    dsp/inthalfbandfilter.h
    dsp/inthalfbandfilterdb.h
    dsp/inthalfbandfilterdbf.h
    dsp/inthalfbandfiltereo.h
    # dsp/inthalfbandfiltereo1.h
    # dsp/inthalfbandfiltereo1i.h
    # dsp/inthalfbandfiltereo2.h
    dsp/inthalfbandfiltereof.h
    dsp/inthalfbandfilterst.h
    dsp/inthalfbandfiltersti.h
    dsp/kissfft.h
    dsp/kissengine.h
    dsp/firfilter.h
    dsp/gaussian.h
    dsp/mimochannel.h
    dsp/misc.h
    dsp/movingaverage.h
    dsp/morsedemod.h
    dsp/nco.h
    dsp/phasediscri.h
    dsp/phaselock.h
    dsp/phaselockcomplex.h
    dsp/projector.h
    dsp/raisedcosine.h
    dsp/recursivefilters.h
    dsp/replaybuffer.h
    dsp/rootraisedcosine.h
    dsp/samplemififo.h
    dsp/samplemofifo.h
    dsp/samplesinkfifo.h
    dsp/samplesimplefifo.h
    dsp/samplesourcefifo.h
    dsp/scopevis.h
    dsp/basebandsamplesink.h
    dsp/basebandsamplesource.h
    dsp/wfir.h
    dsp/devicesamplesource.h
    dsp/devicesamplesink.h
    dsp/devicesamplemimo.h
    dsp/devicesamplestatic.h
    dsp/spectrumvis.h
    dsp/wavfilerecord.h

    device/deviceapi.h
    device/deviceenumerator.h
    device/deviceset.h
    device/deviceuserargs.h
    device/deviceutils.h

    feature/feature.h
    feature/featureset.h
    feature/featureutils.h
    feature/featurewebapiutils.h

    pipes/datafifostore.h
    pipes/datapipes.h
    pipes/datapipesgcworker.h
    pipes/elementpipescommon.h
    pipes/elementpipesgc.h
    pipes/messagepipes.h
    pipes/messagepipesgcworker.h
    pipes/messagequeuestore.h
    pipes/objectpipe.h
    pipes/objectpipesregistrations.h

    plugin/plugininterface.h
    plugin/pluginapi.h
    plugin/pluginmanager.h

    settings/configuration.h
    settings/featuresetpreset.h
    settings/pluginpreset.h
    settings/preferences.h
    settings/preset.h
    settings/mainsettings.h
    settings/rollupstate.h

    util/airlines.h
    util/ais.h
    util/android.h
    util/aprsfi.h
    util/aurora.h
    util/aviationweather.h
    util/ax25.h
    util/aprs.h
    util/astronomy.h
    util/azel.h
    util/baudot.h
    util/callsign.h
    util/colormap.h
    util/coordinates.h
    util/corsproxy.h
    util/countrydat.h
    util/CRC64.h
    util/csv.h
    util/db.h
    util/dsc.h
    util/doublebuffer.h
    util/doublebufferfifo.h
    util/doublebuffermultiple.h

=== sdrbench/CMakeLists.txt ===
project (sdrbench)

if (FT8_SUPPORT)
    set(sdrbench_FT8_LIB ft8)
endif()

set(sdrbench_SOURCES
    mainbench.cpp
    parserbench.cpp
    test_golay2312.cpp
    test_ft8.cpp
    test_callsign.cpp
    test_ft8protocols.cpp
)

set(sdrbench_HEADERS
    mainbench.h
    parserbench.h
)

add_library(sdrbench SHARED
    ${sdrbench_SOURCES}
)

include_directories(
    ${FFTW3F_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/exports
    ${CMAKE_SOURCE_DIR}/sdrbase
    ${CMAKE_SOURCE_DIR}/logging
    ${CMAKE_SOURCE_DIR}
)

if(DEFINED FFTW3F_DEPENDS)
    add_dependencies(sdrbench "${FFTW3F_DEPENDS}")
endif()

target_link_libraries(sdrbench
     Boost::disable_autolinking
    ${FFTW3F_LIBRARIES}
    Qt::Core
    Qt::Gui
    sdrbase
    logging
    ${sdrbench_FT8_LIB}
)

install(TARGETS sdrbench DESTINATION ${INSTALL_LIB_DIR})

=== debian/changelog ===
sdrangel (7.23.1-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Mon, 02 Feb 2026 21:37:03 +0100

sdrangel (7.23.0-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Tue, 13 Dec 2025 18:06:47 +0100

sdrangel (7.22.10-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Mon, 22 Dec 2025 08:26:27 +0100

sdrangel (7.22.9-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 28 Sep 2025 15:58:05 +0200

sdrangel (7.22.8-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Wed, 02 Jul 2025 17:00:39 +0200

sdrangel (7.22.7-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 04 May 2025 17:58:14 +0200

sdrangel (7.22.6-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 02 Feb 2025 18:08:11 +0100

sdrangel (7.22.5-1) unstable; urgency=medium

    * Windows: upload signed releases rather than unsigned releases to Github releases page. PR #2347
    * Windows: fixed signed releases. PR #2344
    * FT8 Demod: limit upper bandwidth to 5.8 kHz. Fixes #2339
    * Stop device while changing channel set. Fixes #2332. PR #2342
    * ADSB: Update URL of OpenSkyNetwork Aircraft database. PR #2341
    * Don't stop source if being deleted. For #2315. PR #2340
    * Send DSPSignalNotification in audio mods for #2336. PR #2340
    * Radiosonde: limit precision of floating point numbers sent to SondeHub. PR #2338
    * Windows signed releases: use relative path. Increase timeout to 30 minutes. PR #2335
    * ADSB: Include adsbdemodsettings.h PR #2334
    * Use release signing certificate for Windows installer. PR #2331
    * Fix memory leak and race condition relating to DSP*Engines. Part of #2159 PR #2330
    * FreeDV: Fix memory allocation/free issues. Part of #2315. PR #2330
    * Wav Files: Add support for meta-data. PR #2328
    * DemodAnalyzer: Ensure sample rate is set in worker. Fixes #2309. PR #2328
    ^ SDRplayv3: Mac: link with libsdrplay_api.so.3 rather than libsdrplay_api.so.3.15. PR #2327
    * ADS-B: Fix memory use after delete. For #1734 and part of #2315 PR #2326
    * Fixed Appveyor Docker image build
    * Fix output-artifact-directory and unzip file. PR #2323

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Thu, 05 Dec 2024 01:07:27 +0100

sdrangel (7.22.4-1) unstable; urgency=medium

    * Use macos-12 for Mac x86 build. PR #2321
    * Workaround for "hdiutil: create failed - Resource busy"
    * Pager: Add alpha and numeric columns. Implements #2319. PR #2320
    * Added qtwebchannel dependecy to fix missing 3d Map and Sky Map from Windows release. PR #2316
    * Removed .deb package build from Appveyor

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Mom, 11 Nov 2024 08:42:03 +0100

sdrangel (7.22.3-1) unstable; urgency=medium

    * Add deb dependencies for pipewire. PR #2314
    * Added compilation options for WebAssembly. PR #2313
    * ADS-B: Use settings keys. PR #2310
    * AIS Demod: Remove spacing around messages. PR #2310
    * Freuqency Scanner: Add multiplex mode. PR #2310
    * Build snap, MAC, Windows and Ubuntu .deb with Github actions. Various PRs
    * Server: Use Sink/MIMO signals rather than Source. Part of #2294. PR #2304
    * Updated some Python scripts to Python3. PR #2298
    * RemoteTCPSink: Does use IQ only setting for RTL0. PR #2301
    * Server: wait for set sample source/sink/MIMO to complete before loading the device settings. Fixes #2294
    * Fix spectrum peak measurement for SSB spectra. Fixes #2282. PR #2299
    * Upgrade C++ standard to c++17
    * Fixes for Android . PR #2288
    * Add qtshadertools. PR #2287
    * Add more Qt modules and set ENABLE_QT6=ON. PR #2287
    * Update Qt optional packages for 6.8 , PR #2287
    * Use Qt 6.8 for Windows build. PR #2287

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sat, 09 Nov 2024 17:30:44 +0100

sdrangel (7.22.2-1) unstable; urgency=medium

    * ChirpChat: increased preamble symbols limit from 20 to 32. Fixes #2284
    * RTLSDR: Apply driver settings in RTLSDRThread Add sync read for WebAssembly. PR #2281
    * SSB demod: fixed GUI and returned to previous threading model. Fixes #2273
    * HeatMap: Catch memory allocation failures... For #2083 PR #2277
    * Add default-qt6-windows cmake config. PR #2276
    * Add pager notifications. Add option to ignore duplicates. Support plotting pager messages on the map. PR #2276
    * Don't load defaults if loading a preset. PR #2274
    * DeviceGUI::closeEvent - Don't automatically delete the GUI,.. PR #2274
    * MainWindow: Add FSMs to avoid blocking on the GUI thread... PR #2274
    * Fix replay buffer when FixReal is qint16. PR #2270
    * snap: Try to get version number from latest tag. PR #2270
    * Add libflac to snap. Set ARCH_OPT to nehalem. PR #2270
    * Fix flac on Mac. PR #2270
    * RemoteTCP: Update docs. PR #2270
    * Map: Fix Kiwi list. Add SDRangel wss support. PR #2270
    * RemoteTCPSink: Report server init errors via GUI. Send protocol to public list. PR #2270
    * RemoteTCPInput: Add wss protocol support. PR #2270
    * Fix DeviceAPI::deserialize. Fixes #2266. PR #2267

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 20 Oct 2024 08:26:38 +0200

sdrangel (7.22.1-1) unstable; urgency=medium

    * wdsprx: Fix path to help file.
    * Removed SyncMessenger from DSPDeviceSourceEngine. Part of #2159
    * Fixed threading model for DSPDeviceSourceEngine. Part of #2159
    * Removed SyncMessenger from DSPDeviceMIMOEngine. Part of #2159
    * RTLSDR: make sure start and stop are effective once only. PArt of #2159
    * Fixed threading model for DSPDeviceMIMOEngine plus other fixes. Part of #2159


=== debian/control ===
Source: sdrangel
Maintainer: Edouard Griffiths, F4EXB <f4exb06@gmail.com>
Section: hamradio
Priority: optional
Standards-Version: 3.9.2
Homepage: https://github.com/f4exb/sdrangel
Build-Depends: debhelper (>= 9),
 libfftw3-dev,
 libopengl-dev,
 qtbase5-dev,
 libqt5opengl5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtmultimedia5-dev,
 libqt5multimedia5-plugins,
 libqt5websockets5-dev,
 libqt5quick5,
 libqt5texttospeech5-dev,
 libqt5gamepad5-dev,
 libqt5svg5-dev,
 qml-module-qtlocation,
 qml-module-qtpositioning,
 qml-module-qtquick-window2,
 qml-module-qtquick-dialogs,
 qml-module-qtquick-controls,
 qml-module-qtquick-controls2,
 qml-module-qtquick-layouts,
 qml-module-qtgraphicaleffects,
 libqt5serialport5-dev,
 libqt5charts5-dev,
 libqt5texttospeech5-dev,
 qtdeclarative5-dev,
 qtpositioning5-dev,
 qtlocation5-dev,
 qtwebengine5-dev,
 qtbase5-private-dev,
 libusb-1.0-0-dev,
 libhidapi-dev,
 libboost-all-dev,
 libasound2-dev,
 libopencv-dev,
 libopencv-imgcodecs-dev,
 libxml2-dev,
 bison,
 cmake,
 flex,
 ffmpeg,
 ninja-build,
 libfaad-dev,
 libflac-dev,
 libavcodec-dev,
 libavformat-dev,
 libopus-dev,
 libairspy-dev,
 libhackrf-dev,
 libuhd-dev,
 libhamlib-dev,
 zlib1g-dev
# TODO:
#   - more dependencies based on version; newer has more devices
#   - manage dependencies not present upstream

Package: sdrangel
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libasound2,
 libgl1,
 libglx-mesa0,
 libqt5multimedia5-plugins,
 libqt5gamepad5,
 libqt5svg5,
 qtspeech5-speechd-plugin,
 pulseaudio | pipewire-pulse,
 ffmpeg,
 gstreamer1.0-libav,
 qml-module-qtlocation,
 qml-module-qtpositioning,
 qml-module-qtquick-window2,
 qml-module-qtquick-dialogs,
 qml-module-qtquick-controls,
 qml-module-qtquick-controls2,
 qml-module-qtquick-layouts,
 qml-module-qtgraphicaleffects
Description: SDR/Analyzer/Generator front-end for various hardware
 SDR/Analyzer/Generator front-end for Airspy, BladeRF, HackRF,
 RTL-SDR, FunCube, LimeSDR, PlutoSDR, RSP, USRP.
 Also File source and sink for I/Q samples, network I/Q sources with
 remote instance.
 Based on Qt5 framework and OpenGL for the spectrum and scope rendering.
 Builds on Linux, Windows and Mac O/S
 Reception modes supported:
   Analog: AM, ATV, NFM, WFM, SSB, broadcast FM, APT, ILS, VOR
   Digital: D-Star, Yaesu SF, DMR, dPMR, FreeDV, M17, DAB, DVB-S, LoRa, ADS-B, Packet (AX.25/APRS), AIS, FT8, Navtex, Radiosonde, RTTY, Pager, Inmarsat C
   Analyzer: Generic channel
 Transmission modes supported:
   Analog: AM, ATV, NFM, SSB, WFM
   Digital: DVB-S, Packet (AX.25), AIS, 802.15.4
Homepage: https://github.com/f4exb/sdrangel

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --parallel --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- -DARCH_OPT=nehalem -DENABLE_EXTERNAL_LIBRARIES=AUTO -DDEBUG_OUTPUT=ON -DBUILD_SERVER=OFF

# delete any external projects (such as libsigmf) that are installed
# would be better if we could prevent them from being installed in CMakeLists.txt
override_dh_install:
	-find debian/sdrangel -type d -name external -exec rm -r {} \; -exec mkdir {} \; -exec rmdir -p {} \;
	dh_install

override_dh_auto_test:
	echo "Skipping test step"

# permit the packaging with /usr/local/lib libraries (from `make install`)
# you can also use `export DEB_DH_SHLIBDEPS_ARGS_ALL=--dpkg-shlibdeps-params=--ignore-missing-info`
# not a good idea!
override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info
